diff --git a/devtools/check-includes.sh b/devtools/check-includes.sh
index ba9d00ba3..3629ab4c7 100755
--- a/devtools/check-includes.sh
+++ b/devtools/check-includes.sh
@@ -80,7 +80,6 @@ include_dir=${1:-build/include}
 	'rte_byteorder_32.h' \
 	'rte_byteorder_64.h' \
 	'generic/*' \
-	'exec-env/*' \
 	'rte_vhost.h' \
 	'rte_eth_vhost.h' \
 	'rte_eal_interrupts.h' \
diff --git a/kernel/linux/kni/kni_dev.h b/kernel/linux/kni/kni_dev.h
index 688f574a4..df46aa70e 100644
--- a/kernel/linux/kni/kni_dev.h
+++ b/kernel/linux/kni/kni_dev.h
@@ -24,7 +24,7 @@
 #include <linux/spinlock.h>
 #include <linux/list.h>
 
-#include <exec-env/rte_kni_common.h>
+#include <rte_kni_common.h>
 #define KNI_KTHREAD_RESCHEDULE_INTERVAL 5 /* us */
 
 #define MBUF_BURST_SZ 32
diff --git a/kernel/linux/kni/kni_fifo.h b/kernel/linux/kni/kni_fifo.h
index 3f4781c2e..5c91b5537 100644
--- a/kernel/linux/kni/kni_fifo.h
+++ b/kernel/linux/kni/kni_fifo.h
@@ -6,7 +6,7 @@
 #ifndef _KNI_FIFO_H_
 #define _KNI_FIFO_H_
 
-#include <exec-env/rte_kni_common.h>
+#include <rte_kni_common.h>
 
 /* Skip some memory barriers on Linux < 3.14 */
 #ifndef smp_load_acquire
diff --git a/kernel/linux/kni/kni_misc.c b/kernel/linux/kni/kni_misc.c
index 04c78eb87..31845e10f 100644
--- a/kernel/linux/kni/kni_misc.c
+++ b/kernel/linux/kni/kni_misc.c
@@ -16,7 +16,7 @@
 #include <net/net_namespace.h>
 #include <net/netns/generic.h>
 
-#include <exec-env/rte_kni_common.h>
+#include <rte_kni_common.h>
 
 #include "compat.h"
 #include "kni_dev.h"
diff --git a/kernel/linux/kni/kni_net.c b/kernel/linux/kni/kni_net.c
index 7371b6d58..be9e6b0b9 100644
--- a/kernel/linux/kni/kni_net.c
+++ b/kernel/linux/kni/kni_net.c
@@ -17,7 +17,7 @@
 #include <linux/kthread.h>
 #include <linux/delay.h>
 
-#include <exec-env/rte_kni_common.h>
+#include <rte_kni_common.h>
 #include <kni_fifo.h>
 
 #include "compat.h"
diff --git a/lib/librte_eal/freebsd/eal/Makefile b/lib/librte_eal/freebsd/eal/Makefile
index 5d5abf1bb..55d476e5b 100644
--- a/lib/librte_eal/freebsd/eal/Makefile
+++ b/lib/librte_eal/freebsd/eal/Makefile
@@ -88,7 +88,6 @@ endif
 
 INC :=  # no bsd specific headers
 
-SYMLINK-$(CONFIG_RTE_EXEC_ENV_FREEBSD)-include/exec-env := \
-	$(addprefix include/exec-env/,$(INC))
+SYMLINK-$(CONFIG_RTE_EXEC_ENV_FREEBSD)-include := $(addprefix include/,$(INC))
 
 include $(RTE_SDK)/mk/rte.lib.mk
diff --git a/lib/librte_eal/linux/eal/Makefile b/lib/librte_eal/linux/eal/Makefile
index 932c93309..2aa6e8c6a 100644
--- a/lib/librte_eal/linux/eal/Makefile
+++ b/lib/librte_eal/linux/eal/Makefile
@@ -95,7 +95,6 @@ endif
 
 INC := rte_kni_common.h
 
-SYMLINK-$(CONFIG_RTE_EXEC_ENV_LINUX)-include/exec-env := \
-	$(addprefix include/exec-env/,$(INC))
+SYMLINK-$(CONFIG_RTE_EXEC_ENV_LINUX)-include := $(addprefix include/,$(INC))
 
 include $(RTE_SDK)/mk/rte.lib.mk
diff --git a/lib/librte_eal/linux/eal/include/exec-env/rte_kni_common.h b/lib/librte_eal/linux/eal/include/rte_kni_common.h
similarity index 100%
rename from lib/librte_eal/linux/eal/include/exec-env/rte_kni_common.h
rename to lib/librte_eal/linux/eal/include/rte_kni_common.h
diff --git a/lib/librte_eal/linux/eal/meson.build b/lib/librte_eal/linux/eal/meson.build
index 7e68b2c0d..d223da638 100644
--- a/lib/librte_eal/linux/eal/meson.build
+++ b/lib/librte_eal/linux/eal/meson.build
@@ -2,10 +2,9 @@
 # Copyright(c) 2017 Intel Corporation
 
 eal_inc += include_directories('include')
-install_subdir('include/exec-env', install_dir: get_option('includedir'))
 
 env_objs = []
-env_headers = []
+env_headers = files('include/rte_kni_common.h')
 env_sources = files('eal_alarm.c',
 		'eal_cpuflags.c',
 		'eal_debug.c',
diff --git a/lib/librte_kni/rte_kni.c b/lib/librte_kni/rte_kni.c
index 492e207a3..192f2fed0 100644
--- a/lib/librte_kni/rte_kni.c
+++ b/lib/librte_kni/rte_kni.c
@@ -21,7 +21,7 @@
 #include <rte_tailq.h>
 #include <rte_rwlock.h>
 #include <rte_eal_memconfig.h>
-#include <exec-env/rte_kni_common.h>
+#include <rte_kni_common.h>
 #include "rte_kni_fifo.h"
 
 #define MAX_MBUF_BURST_NUM            32
diff --git a/lib/librte_kni/rte_kni.h b/lib/librte_kni/rte_kni.h
index 02ca43b4b..9a9a7d754 100644
--- a/lib/librte_kni/rte_kni.h
+++ b/lib/librte_kni/rte_kni.h
@@ -22,7 +22,7 @@
 #include <rte_mempool.h>
 #include <rte_ether.h>
 
-#include <exec-env/rte_kni_common.h>
+#include <rte_kni_common.h>
 
 #ifdef __cplusplus
 extern "C" {